//------------------------------------------------------------>
// Global.vw
//
// Main data entry view
//------------------------------------------------------------>

// Register all objects
Register_Object Delete_Button
Register_Object Exit_Button
Register_Object Index_Button
Register_Object LineControl1
Register_Object LineControl2
Register_Object LineControl3
Register_Object LineControl4
Register_Object LineControl5
Register_Object oFile_Name
Register_Object oFile_Num
Register_Object oHelp_Btn
Register_Object oReplace_View
Register_Object oReturnText
Register_Object oSel_Field_Name
Register_Object oSel_Field_Numb
Register_Object oSelection
Register_Object Replace_Button
Register_Object Replace_Data
Register_Object oIndexLookUp


Use dfClient.pkg
Use Windows.pkg
Use dfEntry.pkg
Use DfLine.Pkg
Use GlbIndexData.dg // Index data entry
Use GlbIndexList.dg // Index pick list


Function Check_File# Returns Integer
    If (FileNumber = 0) Begin
       Send Stop_Box "You Must Select A File From The Selection List -- Use The Popup Button." "Field Error"
       Function_Return 0
    End
    Function_Return 1
End_Procedure

//---------------------------------------------------------->
// Multi dimentional array contains:
//  Field.Name and corresponding Indirect Field Reference
//  i.e.  Myfile.Field   |FS45,3
//
// Populated by DoLoadArray
//---------------------------------------------------------->
String[][2] sNameArray

//---------------------------------------------------------->
// Populate sNameArray with all field names and corresponding
// I-Code replacements
//---------------------------------------------------------->
Procedure DoLoadArray String sFileName
    Integer iMaxFields iType iField# iFile#
    String  sName sFieldRef

    // Initialize the array
    Move (ResizeArray(sNameArray, 0)) to sNameArray

    Move FileNumber to iFile#
    If (iFile# = 0) Begin
        Send Stop_Box "File number is 0"
        Procedure_Return
    End
    Get_Attribute DF_FILE_NUMBER_FIELDS of iFile# to iMaxFields

    // Set to the max number of fields in the selected file
    Move (ResizeArray(sNameArray, iMaxFields)) to sNameArray

    For iField# from 0 to iMaxFields
          Get_Attribute DF_FIELD_NAME of iFile# iField# to sName
          Get_Attribute DF_FIELD_TYPE of iFile# iField# to iType
          If (iType = DF_ASCII or iType = DF_TEXT or iType = DF_OVERLAP or iType = DF_BINARY);
              Move ("|FS"+String(iFile#)+","+String(iField#)) to sFieldRef
          Else If (iType = DF_DATE )  Move ("|FD"+String(iFile#)+","+String(iField#)) to sFieldRef
          Else If (iType = DF_BCD )   Move ("|FN"+String(iFile#)+","+String(iField#)) to sFieldRef
          //------------------------------------------------->
          //- do not permit use of overlap fields
          //------------------------------------------------->
          If (iType <> DF_OVERLAP) Begin
                Move (uppercase(sFileName+"."+sName)) to sNameArray [iField#][0]
                Move (uppercase(sFieldRef)) to sNameArray [iField#][1]
          End
    Loop

    // test the array
    //Move (SizeOfArray(sNameArray)) to iMaxFields
    //For iField# from 0 to (iMaxFields-1)
        //Showln "val: " sNameArray[iField#][0] " " sNameArray[iField#][1]
    //Loop

End_Procedure

//-------------------------------------------->
// Test the string to see if a mathematical
// operator is contained in it.  If so, return
// the position.
//-------------------------------------------->
Function IsOperator String sval Returns Integer
       Integer iCount iTestLength

       Move (length(sval)) to iTestLength
       If (iTestLength = 0) Function_Return 0

       For iCount from 1 to (length(sval))
       If (mid(sval,1,iCount)) in "=<>" Function_Return iCount
       Loop

       Function_Return 0
End_Function

//-------------------------------------------->
//
// Pass in:          CUSTOMER.MY_DATE=12/31/1999"
// Returns in form:  |FD103,33="12/31/1999"
//-------------------------------------------->
Function doProcessReplace String sExpStr Returns String
      Integer iCount iField# iPosition iOffSet_obj iDecimal iOperator iPos iLen
      String sField_Name sOffSet# sLookFor sOrigExp sNewExp sTemp

      Move (SizeOfArray(sNameArray)) to iCount

      For iField# from 0 to (iCount - 1)
         Move sNameArray[iField#][0] to sField_Name
         Move sNameArray[iField#][1] to sOffSet#

         If (sExpStr contains trim(sField_Name)) Begin
            // Find A Match And Replace The Field Name With The Offset expression
            Move (Replaces(sField_Name,sExpStr,sOffSet#)) to sExpStr
         End
      Loop

      Function_Return sExpStr
End_Function

//-------------------------------------------------------------->
// Another multidimentional array, this one for holding:
// file.field, trailing operator
//-------------------------------------------------------------->
String[][] sFields

//-------------------------------------------------------------->
// Break up the selection statement into it's separate pieces
// with the AND/OR operator that separates them if any.  Put
// each statement into sFields as element 0, the following
// operator into element 1, if any.
//-------------------------------------------------------------->
Function iGetParseLineToArray String sExpStr Returns Integer
    String sParseLine sOperator
    Integer iCount iPos iLen iMaxFields iField# iOperator
      Move (Uppercase(sExpStr)) to sExpStr
      Move (trim(sExpStr)) to sParseLine
      If ((sParseLine contains " AND ") or (sParseLine contains "OR")) Begin
            Move 1 to iCount
            While (iCount)
               Move "" to sOperator
               // Determine which operator and it's position
               Move (pos(" AND ", sParseLine)) to iPos
               If (iPos) Move "and" to sOperator
               If (iPos = 0) Begin
                   Move (pos(" OR ", sParseLine)) to iPos
                   If (iPos) Move "or" to sOperator
               End
               // We're at the last section
               If (iPos = 0) Move (Length(sParseLine)) to iPos

               // Save off each side of the statment to the array
               // iPos = position of the first operator
               Move (Left(sParseLine, iPos)) to sFields[(iCount-1)][0]
               Move sOperator to sFields[(iCount-1)][1]
               // We have the field and operator
               Move (Length(sParseLine)) to iLen
               Move (Right(sParseLine, (iLen-iPos))) to sParseLine
               // AND INVOICE.BRAND = "ABCD"
               // If an "=" style operator in the line, we have another to parse
               Move (IsOperator(Self, sParseLine)) to iOperator
               If (iOperator = 0) Move 0 to iCount
               Else Increment iCount
               // Remove the leading operator
               Move (Length(sParseLine)) to iLen
               // Find blank after "and" or "or"
               Move (pos(" ", sParseLine)) to iPos
               Move (Right(sParseLine, (iLen-iPos))) to sParseLine
               Move (trim(sParseLine)) to sParseLine
            Loop
      End
      Else Begin
          Move sExpStr to sFields[0][0]    // A single selection statement
          Move ""      to sFields[0][1]    //
      End

    // Test array
    //Move (SizeOfArray(sFields)) to iMaxFields
    //For iField# from 0 to (iMaxFields-1)
        //Showln "val: " sFields[iField#][0] " " sFields[iField#][1]
    //Loop

End_Function

//---------------------------------------------------------->
// Read the above arrays and replace each file.field name
// with the corresponding I-Code replacement, and then finally
// reassemble the whole statement so that instead of:
//
//   INVOICE.INVOICE_TYPE = "ABCD" and INVOICE.BRAND = "DEFG"
//
// we have:
//
//   |FS36,18 = "ABCD" and |FS36,43 = "DEFG"
//
//---------------------------------------------------------->
Function DoProcessSelection String sExpStr Returns String
      Integer iRC iCount iField# iOperator iFieldsArray iSelCount
      String sField_Name sOffSet# sLookFor sParseLine sReturnSel sOperator

      Get iGetParseLineToArray sExpStr to iRC

      Move (SizeOfArray(sNameArray)) to iCount
      Move (SizeOfArray(sFields)) to iFieldsArray

      // Outer loop is the selection fields from sFields
      For iSelCount from 0 to (iFieldsArray - 1)

          Move sFields[iSelCount][0] to sParseLine
          Move sFields[iSelCount][1] to sOperator

          // Inner loop is to find each I-Code replacement
          // for the corresponding field in sFields
          For iField# from 0 to (iCount - 1)
             Move sNameArray[iField#][0] to sField_Name
             Move sNameArray[iField#][1] to sOffSet#

             Move (IsOperator(Self, sParseLine)) to iOperator
             Move (Left(sParseLine, (iOperator-1))) to sLookfor

             If (trim(uppercase(sLookFor)) = trim(uppercase(sField_Name))) Begin
                // Find A Match And Replace The Field Name With The Offset expression
                // invoice.invoice_type = invoice.invoice_type
                Move (Replaces(sField_Name,sParseLine,sOffSet#)) to sParseLine
                If (iField# > 0 and sParseLine <> "") Move (sReturnSel+" "+sParseLine+" "+sOperator) to sReturnSel
                Else Move (trim(sParseLine)) to sReturnSel
             End
          Loop  // iField#

      Loop  // iSelCount

      Function_Return (trim(sReturnSel))
End_Function


ACTIVATE_VIEW Activate_oReplace_View FOR oReplace_View

Object oReplace_View is a dbView

    //--------------------------------------------------->
    // There are no data aware controls in the application,
    // but the dbView class is used so we can subvert the
    // request_clear methods to clear our entry fields.
    //--------------------------------------------------->

    Set Caption_Bar to False
    Set View_Mode to Viewmode_Zoom
    Set SysMenu_Icon To False

    Procedure Request_Clear
        Send Clear_Fields
        Send Activate to oFile_Name
    End_Procedure

    Procedure Request_Clear_All
        Send Clear_Fields
        Send Activate to oFile_Name
    End_Procedure

    ON_KEY Key_Alt+Key_R SEND Process
    ON_KEY Key_Alt+Key_L SEND Deletions
    ON_KEY Key_Alt+Key_I SEND Indexes
    ON_KEY Key_Alt+Key_X SEND Exit_Application
    On_Key KHelp         Send OnClick to oHelp_Btn


    Property String  psNeed_Fld#          Public ""
    Property String  psJumpIn_Data        Public ""
    Property String  psJumpOut_Data       Public ""
    Property String  psIndex_Segment      Public ""
    Property String  psSelection          Public ""
    Property String  psReplace            Public ""
    Property String  psFileName     	  Public ""
    Property String  psFieldName    	  Public ""
    Property Integer piCurrent_Field_Obj  Public 0
    Property Integer piIndex#             Public 0
    Property Integer piReplField#         Public 0
    Property Integer piFieldNumber        Public 0

    Procedure Process
        Integer iDoIt
        Get Check_File# To iDoIt
        If iDoIt Send Record_Update
    End_Procedure

    Procedure Deletions
        Integer iDoIt
        Get Check_File# To iDoIt
        If iDoIt Send Record_Deletion
    End_Procedure

    Procedure Indexes
        Integer iDoIt
        Get Check_File# To iDoIt
        If iDoIt Send Popup To (oIndexEntry(Self))
    End_Procedure

    Procedure Clear_Fields
        Move 0 to FileNumber
        Set Value of oFile_Name to ""
        Set Value of oFile_Numb to ""
        Set Value of oSelection to ""
        Set Value of oSel_Field_Name to ""
        Set Value of oSel_Field_Numb to ""
        Set Value of Replace_Data to ""
        Move 0 to FileNumber
        Set psFileName to ""
        Set psNeed_Fld# to ""
        Set piCurrent_Field_Obj to 0
        Set piIndex# to 0
        Set psJumpIn_Data to ""
        Set psJumpOut_Data to ""
        Set psIndex_Segment to ""
        Set psSelection to ""
        Set psReplace to ""
    End_Procedure

    //=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Pick Lists =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

    Use GlbFileList.dg  // File Name Pick List
    Use GlbFieldList.dg   // Field Name Pick List

    //=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Processing =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

    Procedure Setup_fields
       Integer iFile#
       String Lname gdsDfpath

       If (psFileName(Self) = "") Begin
          Send Stop_box "Please select a file from the selection list -- F4." "Field Error"
          Procedure_return 1
       End
       Move FileNumber to iFile#

       Open iFile#

       Send DoLoadArray (psFileName(Self))

    End_Procedure

    //=-=-=-=-=-=-=-=-=-=-=-=-= Record Updating =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

    Procedure Record_Update
        String sAnswer sSegment sJumpin_Data sJumpOut_Data sField
        String sTemp sMsg sEval_Str sSelection sReplace sJumpout_Test
        Integer iCounter iItem_Count iIndex# iHoldFI iStatPnl iRecnum
        Integer iUserCancel iFile# iField# iGetOut iReplField#

        Get psSelection   to   sSelection
        Get psReplace     to   sReplace
        Move FileNumber   to   iFile#
        Get piFieldNumber to   iField#   // Replacement field

        If (iField# = 0 OR iFile# = 0) begin
            Send Stop_Box "ERROR! No file or field selected for update."
            Procedure_Return
        end
        //------------------------------------------------->
        // Get The File.Field Name
        //- "Replace with" data
        //------------------------------------------------->
        Get doProcessReplace   (trim(sReplace))  to sReplace
        // check to see if the user maybe typed something in incorrectly
        // rather than use the lookup list
        Move sSelection to sTemp
        Get doProcessSelection (trim(sTemp)) to sSelection
        If (sTemp <> "" and sSelection = "") Begin
            Send Stop_Box "The selection you entered did not evaluate correctly, verify your entry." "Error!"
            Procedure_Return
        End

        Move (SizeOfArray(sNameArray)) to iItem_Count

        //------------------------------------------------->
        //- Get choices from the screen
        //------------------------------------------------->
        Get piIndex#                    to iIndex#
        Get psIndex_Segment             to sSegment
        Get psJumpin_Data               to sJumpin_Data     // "Jump In" Data
        Get psJumpout_Data              to sJumpout_Data    // "Jump Out" Data
        Get value of oSel_Field_Numb    to iReplField#      // Field # being replaced

        //------------------------------------------------->
        // We Have Index #,
        // We Have Data To Jump In,
        // We Have The Fieldindex Of The First Field In The Index.
        //------------------------------------------------->
        trim (psFileName(Self)) To sTemp
        Append sTemp "." sSegment

        Clear iFile#

        If (iIndex# > 0) Begin
           //------------------------------------------------->
           // If Other Than Recnum, Move "Jump-In" Data To Field
           //------------------------------------------------->
           Set_Field_Value iFile# iReplField# to sJumpin_Data
           Vfind iFile# iIndex# Ge
           Get_Field_Value iFile# iReplField# to sTemp
           Indicate Found as (sTemp = sJumpin_Data)
        End
        Else Vfind iFile# iIndex# Ge

        If Not (Found) Begin
            Send Info_Box "No records found for update."
            Procedure_Return
        End

        Move (Status_Panel(Self)) to iStatPnl
        Send Initialize_StatusPanel to iStatPnl "Processing" "Updating Records" ""
        Send Start_StatusPanel to iStatPnl

        While (Found and not(iUserCancel))

           Get_Field_Value iFile# 0 to iRecnum
           Send Update_StatusPanel to iStatPnl iRecnum
           Get Check_StatusPanel of iStatPnl to iUserCancel
           //------------------------------------------------->
           // Evaluate the data selection field, 0=false
           //------------------------------------------------->
           // troubleshooting
           // Get_Field_Value iFile# iReplField# to sTemp

           If (Eval(sSelection) Ne False) Begin

              Reread
              Set_Field_Value iFile# iField# to (Eval(sReplace))
              SaveRecord iFile#
              Unlock

              Increment iCounter

           End
           Vfind iFile# iIndex# Gt

           //------------------------------------------------->
           // If the "jumpout" data is present, get out
           //------------------------------------------------->
           If (sJumpOut_Data <> "" and iIndex# > 0) Begin
              Get_Field_Value iFile# iReplField# to sJumpout_Test
              If (Found and sJumpout_Test >= sJumpOut_Data) Indicate Found False
           End

        End  // While Loop

        Send Stop_StatusPanel to iStatPnl
        Send Info_Box ("All done, "+string(iCounter)+" replacements.")
    End_Procedure

    //=-=-=-=-=-=-=-=-=-=-=-=-=-= Record Deletion =-=-=-=-=-=-=-=-=-=-=-=-=-=

    //------------------------------------------------->
    // Deletions always use recnum index
    //------------------------------------------------->

    Procedure Record_Deletion
        String lTemp lMsg lEval_Str sSelection sReplace
        Integer iCounter lItem_Count lIndex# lHoldFI iLast_Rec iStatPnl iUserCancel iFile#

        Get psSelection to sSelection
        Get psReplace   to sReplace
        Move FileNumber to iFile#

        Get doProcessSelection sSelection to sSelection

        If ((iFile# = 0) Or (Length(sSelection) = "")) Begin
            Send Stop_Box "ERROR! No file or selection entered for deletion."
            Procedure_Return
        end

        Clear iFile#

        Vfind iFile# 0 Gt

        If Not (Found) Begin
            Send Info_Box "No records found for deletion."
            Procedure_Return
        End

        Move (Status_Panel(Self)) to iStatPnl
        Send Initialize_StatusPanel to iStatPnl "Processing" "Deleting Records" ""
        Send Start_StatusPanel to iStatPnl

        While (Found and not(iUserCancel))

           Get_Field_Value iFile# 0 to iLast_Rec
           Send Update_StatusPanel to iStatPnl iLast_Rec
           Get Check_StatusPanel of iStatPnl to iUserCancel

           If (Eval(sSelection) Ne False) Begin
              Increment iCounter
              Lock
                Delete iFile#
                Clear  iFile#
                Set_Field_Value iFile# 0 to iLast_Rec
              Unlock
           End
           Vfind iFile# 0 Gt

        End  //End While Loop

        Send Stop_StatusPanel to iStatPnl
        Send Info_Box ("All done, "+string(iCounter)+" deletions.")
    End_Procedure

    //=-=-=-=-=-=-=-=-=-=-=-=-=-=-= Data Entry =-=-=-=-=-=-=-=-=-=-=-=-=-=-=

    Set Label to "Global Data Replacement Utility"
    Set Location to 2 2
    Set Size to 202 475

    Object oFile_Name is a Form
        Set Label to "File Name:"
        Set Size to 13 117
        Set Location to 10 66
        Set Label_Col_Offset to 40

        Set Capslock_State to True
        Set Prompt_Button_Mode to pb_PromptOn
        Set Form_Button_Bitmap 0 To 'Prompt.Bmp'

        Procedure Prompt
            Set psJumpin_Data To ""
            Set piIndex#     To 0
            Send Popup to oFileLookup
            Forward Send Prompt
            Set Value to (psFileName(Self))
        End_Procedure

        Procedure Exiting Integer iToObj
            Integer hFile iFile# iFail
            string sName sFileName

            Forward Get MSG_Exiting iToObj to iFail

            If (not(iFail)) Begin
                Get Value item 0 to sFileName
                Set psFileName to sFileName

                //----------------------------------------------------->
                //- Selection list populates Filenumber & liFile#,
                //- if 0 need to get it
                //----------------------------------------------------->
                If (sFileName <> "") Begin
                    Repeat
                        //----------------------------------------------------->
                        // Spin through the filelist to find the file number
                        // from the file root name
                        //----------------------------------------------------->
                        Get_Attribute DF_FILE_NEXT_USED of hFile to hFile
                        If (hFile > 0) Begin
                            Get_Attribute DF_FILE_LOGICAL_NAME of hFile to sName
                            // 7/30/02  To accomodate foreign files
                            If (uppercase(sName) contains uppercase(sFileName)) Move hFile to iFile#
                        End
                        If (iFile# > 0) Break
                    Until (hFile=0)
                End
                If (iFile# > 0) Send Entry_Display to oFile_Numb 0 1
                Else Begin
                    If (iToObj <> Exit_Button(Self) and iToObj <> oHelp_Btn(Self)) Begin
                        Send Stop_Box "The file name is not valid, please enter one or use the list."
                        Procedure_Return 1
                    End
                End
                //----------------------------------------------------->
                // Use FileNumber as a global variable to carry the file
                // number around
                //----------------------------------------------------->
                Move iFile# to FileNumber
                Set Value of (oFile_Numb(Self)) item 0 to iFile#
                If iFile# Ne "" Send Setup_Fields
            End

            Procedure_Return iFail
        End_Procedure

    End_Object    // oFile_Name

    Object oFile_Numb is a dbForm
        Set Label to "File Number:"
        Set Size to 13 48
        Set Location to 10 305
        Set Label_Col_Offset to 45
        Set Enabled_State to False
    End_Object    // oFile_Numb

    Object oSelection is a Form
        Set Label to "Selection:"
        Set Size to 13 391
        Set Location to 49 67
        Set Label_Col_Offset to 38

        Set Prompt_Button_Mode to pb_PromptOn
        Set Form_Button_Bitmap 0 To 'Prompt.Bmp'

        Procedure Prompt
            Send Popup to oFieldLookup
            Forward Send Prompt
        End_Procedure

        Procedure Entering
            Set piCurrent_Field_Obj To Self
            Set psNeed_Fld#         To ""
            Forward Send Entering
        End_Procedure

        Procedure Exiting Integer iToObj
            String sSelection sChar
            Integer iFail
            Forward Get MSG_Exiting iToObj to iFail
            If (not(iFail)) Begin
                Get Value item 0 to sSelection
                Set psSelection to sSelection
            End
            Procedure_Return iFail
        End_Procedure

    End_Object    // oSelection

    Object oSel_Field_Name is a dbForm
        Set Label to "Field To Replace:"
        Set Size to 13 150
        Set Location to 88 67

        Set Capslock_State to True
        Set Prompt_Button_Mode to pb_PromptOn
        Set Form_Button_Bitmap 0 To 'Prompt.Bmp'

        Procedure Prompt
            Set piFieldNumber to 0
            Send Popup to oFieldLookup
            Forward Send Prompt
        End_Procedure

        Procedure Entering
            Set psNeed_Fld#         To "Y"
            Set piCurrent_Field_Obj To Self
            Forward Send Entering
        End_Procedure

        Procedure Exiting Integer iToObj
            Integer iField# iFileNum iFail
            String  sFieldName

            Forward Get MSG_Exiting iToObj to iFail
            If (not(iFail)) Begin
                Get Value to sFieldName
                If (sFieldName contains ".") Begin
                   Send Stop_Box "ERROR! It appears that the field name contains the file name as well, please remove."
                   Procedure_Return 1
                End
                Get Value of oSel_Field_Numb to iField#
                If (sFieldName > "") Begin
                    Indicate ERR False
                    Field_Map FileNumber (trim(sFieldName)) to iField#
                    If (ERR) Procedure_Return 1
                    Set piFieldNumber to iField#
                    If (iField# > 0);
                        Set value of oSel_Field_Numb to iField#
                End
            End
            Procedure_Return iFail
        End_Procedure

    End_Object    // oSel_Field_Name

    Object oSel_Field_Numb is a dbForm
        Set Label to "Field Number:"
        Set Size to 13 48
        Set Location to 88 305
        Set Label_Col_Offset to 50
        Set Enabled_State to False
    End_Object    // oSel_Field_Numb

    Object Replace_Data is a dbForm
        Set Label to "Replace With:"
        Set Size to 13 393
        Set Location to 127 66
        Set Label_Col_Offset to 50

        Set Prompt_Button_Mode to pb_PromptOn
        Set Form_Button_Bitmap 0 To 'Prompt.Bmp'

        Procedure Prompt
            Send Popup to oFieldLookup
            Forward Send Prompt
        End_Procedure

        Procedure Entering
            Set psNeed_Fld#         To ""
            Set piCurrent_Field_Obj To Self
            Forward Send Entering
        End_Procedure

        // Yeah, this could whine if the user had a wrong
        // value, was in this field, and switched workspaces
        Procedure Exiting Integer iToObj
            String sReplace sChar
            Integer iFail

            If (iToObj = Exit_Button(Self) or iToObj = oHelp_Btn(Self)) Procedure_Return 0

            Forward Get MSG_Exiting iToObj to iFail
            If (not(iFail)) Begin
                Get Value item 0 to sReplace
                If (sReplace = "") Procedure_Return iFail
                // Test for date
                Move (left(sReplace,1)) to sChar
                If (sReplace contains "/" and (sChar <> '"' and sChar <> "'")) Begin
                    Send Stop_Box "The replacement value appears to be a date but without quotes, which are necessary.  Please fix."
                    Procedure_Return 1
                End
                Set psReplace to sReplace
            End
            Procedure_Return iFail
        End_Procedure

    End_Object    // Replace_Data

    Object oHelp_Btn is a Button
        Set Label to "Help"
        Set Location to 167 17

        Procedure OnClick
            String sHelpPath sHelpFile sRegKey sRegValue
            Integer iRC bOpened

            Move "Software\Data Access Worldwide\Visual DataFlex\12.0" to sRegKey
            Move "GlobalHelpDirectory" to sRegValue

            Get OpenKey of oRegistry sRegKey to bOpened
            If bOpened Begin
                If (ValueExists(oRegistry(Self), sRegValue));
                    Get ReadString of oRegistry sRegValue to sHelpFile
                Send CloseKey to oRegistry
            End

            If (sHelpFile <> "") Send vShellExecute "Open" sHelpFile "" ""
			// Send Help
        End_Procedure // OnClick

    End_Object    // oHelp_Btn

    Object Replace_Button is a Button
        Set Label to "&Replace"
        Set Location to 167 235

        Procedure OnClick
            Integer iDoIt
            Get Check_File# To iDoIt
            If iDoIt Send Record_Update
        End_Procedure

    End_Object    // Replace_Button

    Object Delete_Button is a Button
        Set Label to "De&Lete"
        Set Location to 167 294

        Procedure OnClick
            Integer iDoIt iRC
            Get Check_File# To iDoIt
            Get Yesno_Box "Are you sure you want to delete this data?" to iRC
            If (iRC = 6 and iDoIt) Send Record_Deletion
        End_Procedure

    End_Object    // Delete_Button

    Object Index_Button is a Button
        Set Label to "&Indexes"
        Set Location to 167 353

        Procedure OnClick
            Integer iDoIt
            Get Check_File# To iDoIt
            If iDoIt Send Popup to (oIndexEntry(Self))
        End_Procedure

    End_Object    // Index_Button

    Object Exit_Button is a Button
        Set Label to "E&Xit"
        Set Location to 167 413

        Procedure OnClick
            Send Exit_Application To Desktop
        End_Procedure

    End_Object    // Exit_Button

    Object LineControl1 is a LineControl
        Set Size to 2 463
        Set Location to 33 4
    End_Object    // LineControl1

    Object oReturnText is a Textbox
        Set Label to "For all fields below, enclose string and date data in quotes, but not numbers."
        Set Location to 36 124
        Set Size to 10 250
        Set TypeFace to "MS Sans Serif"
    End_Object    // oReturnText

    Object LineControl2 is a LineControl
        Set Size to 2 463
        Set Location to 74 4
    End_Object    // LineControl2

    Object LineControl3 is a LineControl
        Set Size to 2 51
        Set Location to -25207 -21846
    End_Object    // LineControl3

    Object LineControl4 is a LineControl
        Set Size to 2 461
        Set Location to 113 5
    End_Object    // LineControl4

    Object LineControl5 is a LineControl
        Set Size to 2 463
        Set Location to 152 4
    End_Object    // LineControl5

End_Object    // oReplace_View

